#pragma comment(lib, "ws2_32")
#include <winsock2.h>
#include <ws2tcpip.h>
#include <stdlib.h>
#include <stdio.h>

#define SERVERIP   "::1"
#define SERVERPORT 9000
#define BUFSIZE    512

//  Լ    
void err_quit(char *msg)
{
	LPVOID lpMsgBuf;
	FormatMessage(
		FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_FROM_SYSTEM,
		NULL, WSAGetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR)&lpMsgBuf, 0, NULL);
	MessageBox(NULL, (LPCTSTR)lpMsgBuf, msg, MB_ICONERROR);
	LocalFree(lpMsgBuf);
	exit(1);
}

//  Լ  
void err_display(char *msg)
{
	LPVOID lpMsgBuf;
	FormatMessage(
		FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_FROM_SYSTEM,
		NULL, WSAGetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR)&lpMsgBuf, 0, NULL);
	printf("[%s] %s", msg, (char *)lpMsgBuf);
	LocalFree(lpMsgBuf);
}

int main(int argc, char *argv[])
{
	int retval;

	//  ʱȭ
	WSADATA wsa;
	if(WSAStartup(MAKEWORD(2,2), &wsa) != 0)
		return 1;

	// socket()
	SOCKET sock = socket(AF_INET6, SOCK_DGRAM, 0);
	if(sock == INVALID_SOCKET) err_quit("socket()");

	//  ּ ü ʱȭ
	SOCKADDR_IN6 serveraddr;
	ZeroMemory(&serveraddr, sizeof(serveraddr));
	serveraddr.sin6_family = AF_INET6;
	int addrlen = sizeof(serveraddr);
	WSAStringToAddress(SERVERIP, AF_INET6, NULL,
		(SOCKADDR *)&serveraddr, &addrlen);
	serveraddr.sin6_port = htons(SERVERPORT);

	//  ſ  
	SOCKADDR_IN6 peeraddr;
	char buf[BUFSIZE+1];
	int len;

	//   
	while(1){
		//  Է
		printf("\n[ ] ");
		if(fgets(buf, BUFSIZE+1, stdin) == NULL)
			break;

		// '\n'  
		len = strlen(buf);
		if(buf[len-1] == '\n')
			buf[len-1] = '\0';
		if(strlen(buf) == 0)
			break;

		//  
		retval = sendto(sock, buf, strlen(buf), 0,
			(SOCKADDR *)&serveraddr, sizeof(serveraddr));
		if(retval == SOCKET_ERROR){
			err_display("sendto()");
			continue;
		}
		printf("[UDP Ŭ̾Ʈ] %dƮ ½ϴ.\n", retval);

		//  ޱ
		addrlen = sizeof(peeraddr);
		retval = recvfrom(sock, buf, BUFSIZE, 0,
			(SOCKADDR *)&peeraddr, &addrlen);
		if(retval == SOCKET_ERROR){
			err_display("recvfrom()");
			continue;
		}

		// ۽ IP ּ üũ
		peeraddr.sin6_flowinfo = 0; /* Windows XP IPv6  ϱ(  ڵ) */
		if(memcmp(&peeraddr, &serveraddr, sizeof(peeraddr))){
			printf("[] ߸ Դϴ!\n");
			continue;
		}

		//   
		buf[retval] = '\0';
		printf("[UDP Ŭ̾Ʈ] %dƮ ޾ҽϴ.\n", retval);
		printf("[ ] %s\n", buf);
	}

	// closesocket()
	closesocket(sock);

	//  
	WSACleanup();
	return 0;
}